// ファイル名 : CalcFuncsClass.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;

namespace csSimpleDLL
{
    //--------------------------------------------------------------------
    //  インターフェイスの定義 (dispinterface) 用のコード
    //  元の DLL のコードに追加した部分
    //--------------------------------------------------------------------
    [Guid("3C809CC0-E8C6-408C-8843-F290F38E54B3")]
    public interface ICalcFuncs
    {
        // 使用する関数類を列挙
        String GetText();
        int AddInt(int AInt1, int AInt2);
    }

    //--------------------------------------------------------------------
    //  interface(IDispatch) の定義部分
    //  元の DLL のコードに追加した部分
    //--------------------------------------------------------------------
    [ClassInterface(ClassInterfaceType.None)]
    [ProgId("csSimpleDLL.CalcFuncs")]
    [Guid("B835F7A6-B8E3-4336-9010-0BAFE7EE4DED")]

    //--------------------------------------------------------------------
    //  クラス名の後にインターフェイス名を付加
    //  それ以外は元の DLL のコードと同じ
    //--------------------------------------------------------------------
    public class CalcFuncs : ICalcFuncs
    {
        public String GetText()
        {
            return "日本語 ABC 文字列";
        }
        public int AddInt(int AInt1, int AInt2)
        {
            return AInt1 + AInt2;
        }
    }
}    